﻿SLASH_INTERRUPTMANAGER1, SLASH_INTERRUPTMANAGER2 = '/im', '/interruptmanager'

function InterruptManager_OnLoad()
    InterruptManager:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end
function ManageInterrupts_OnLoad()
    ManageInterrupts:RegisterEvent("CHAT_MSG_ADDON")
end
function InterruptManagerQueue_OnLoad()
    InterruptManagerQueue:RegisterEvent("CHAT_MSG_ADDON")
end

local interrupter
local announce = 1
interruptSpells = {80964, 80965, 5211, 78675, 47528, 47476, 2139, 1766, 51680, 34490, 57994, 19647, 26090, 6552, 15487, 72}

function InterruptManager_OnEvent(self, event, ...)
    if (GetNumRaidMembers() == 0) then
        group = "PARTY"
    else
        group = "RAID"
    end
    local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
    if (type == "SPELL_CAST_SUCCESS") then
        local spellID, spellName, spellSchool = select(9, ...)
        interrupter = sourceName
        if (tContains(interruptSpells, spellID)) then
            if (interrupter == GetUnitName("player") and announce == 1) then
                SendChatMessage("Used "..spellName)
            end
            if IsPartyLeader() then
                SendAddonMessage("InterruptManager","Rotate", group)
            end
        end
    end
end

function ManageInterrupts_OnEvent(self, event, ...)
    local addon, msg = select(1, ...)
    if (queueNum == nil) then
        if (msg == "Rotate") then
            print("Warning: Interrupt rotation is not set.")
        end
    else
        if (msg == "Rotate" and addon == "InterruptManager") then
            if (queueNum ~= 0) then
                queueNum = queueNum - 1
                if (queueNum == 0) then
                    queueNum = numInterrupters
                end
            end
            if (queueNum == 1 and interrupter ~= GetUnitName("player")) then
                SendChatMessage("I'm interrupting next!", "SAY")
                PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
            end
            if (interrupter == GetUnitName("player") and queueNum == 1) then
                SendAddonMessage("InterruptManager","Correct",group)
                interrupter = nil
            end
        end
        if (msg == "Correct" and addon == "InterruptManager") then
            if (queueNum ~= 0) then
                queueNum = queueNum - 1
            end
            if (queueNum == 0 and interrupter ~= GetUnitName("player")) then
                queueNum = numInterrupters
            end
        end
    end
    print(queueNum)
end
function SlashCmdList.INTERRUPTMANAGER(msg, editbox)
    IMConfigFrame:Show()
end

function IMUpdateInterrupters()
    numInterrupters = 5
    if (getglobal("IMConfigEditbox1"):GetText() == "First interrupter") then
        numInterrupters = numInterrupters - 1
    elseif (getglobal("IMConfigEditbox1"):GetText() ~= "") then
        SendAddonMessage("InterruptManagerQueue", 1, "WHISPER", getglobal("IMConfigEditbox1"):GetText())
    end
    if (getglobal("IMConfigEditbox2"):GetText() == "Second interrupter") then
        numInterrupters = numInterrupters - 1
    elseif (getglobal("IMConfigEditbox2"):GetText() ~= "") then
        SendAddonMessage("InterruptManagerQueue", 2, "WHISPER", getglobal("IMConfigEditbox2"):GetText())
    end
    if (getglobal("IMConfigEditbox3"):GetText() == "Third interrupter") then
        numInterrupters = numInterrupters - 1
    elseif (getglobal("IMConfigEditbox3"):GetText() ~= "") then
        SendAddonMessage("InterruptManagerQueue", 3, "WHISPER", getglobal("IMConfigEditbox3"):GetText())
    end
    if (getglobal("IMConfigEditbox4"):GetText() == "Fourth interrupter") then
        numInterrupters = numInterrupters - 1
    elseif (getglobal("IMConfigEditbox4"):GetText() ~= "") then
        SendAddonMessage("InterruptManagerQueue", 4, "WHISPER", getglobal("IMConfigEditbox4"):GetText())
    end
    if (getglobal("IMConfigEditbox5"):GetText() == "Fifth interrupter") then
        numInterrupters = numInterrupters - 1
    elseif (getglobal("IMConfigEditbox5"):GetText() ~= "") then
        SendAddonMessage("InterruptManagerQueue", 5, "WHISPER", getglobal("IMConfigEditbox5"):GetText())
    end
    for i=1,5 do
        if (getglobal("IMConfigEditbox"..i):GetText() == "") then
            numInterrupters = numInterrupters -1
        end
    end
    SendAddonMessage("InterruptManagerNumInterrupters", numInterrupters, group)
end

function InterruptManagerQueue_OnEvent(self, event, ...)
    local addon, msg = select(1, ...)
    if (addon == "InterruptManagerQueue") then
        queueNum = msg
    end
    if (addon == "InterruptManagerNumInterrupters") then
        numInterrupters = msg
    end
end

function IMAnnounceToggle()
    if (announce == 1) then
        announce = 0
        IMConfigAnnounceToggleButton:SetText("Enable Announce")
    else
        announce = 1
        IMConfigAnnounceToggleButton:SetText("Disable Announce")
    end
end